; APD v1.0 pour Doorsos v0.85 ( ou superieur )
; par Alban Gervaise
; derniere modification le 01/02/99

        include "doorsos.h"           ; librairie a utilisee
        include "graphlib.h"          ;
        include "userlib.h"           ;
        include "apdpic.asm"          ; la fenetre

        xdef _ti89
        xdef _main
        xdef _comment

        dc.l 'ICON'                   ; icone pour Proshell v1.1
        dc.w %0000011111100000
        dc.w %0000100010010000
        dc.w %0001000010001000        ; hey! c'est une horloge :)
        dc.w %0001000110001000
        dc.w %0001011000001000
        dc.w %0000100000010000
        dc.w %0000011111100000
        dc.w %0000100000010000

_main   move.l APD_INIT,apd_timer     ; on sauve la valeur de l'APD
        clr.w -(a7)
        jsr doorsos::ST_busy          ; on efface "busy"
        pea.l doc(pc)
        jsr doorsos::ST_showHelp      ; on affiche un peu de doc en bas
        lea 6(a7),a7
        cmp.l #600-95*5,APD_INIT      ; on verifie si les valeurs sont bonnes
        ble.s petit                   ; trop petit alors on met a 10 sec
        cmp.l #11410+95,APD_INIT      ; trop grand?
        blt redraw                    ; non alors on dessine la fenetre

grand   move.l #11415,APD_INIT        ; trop grand on met a 10 min et on recommence
        bra.s _main
petit   move.l #580-95*4,APD_INIT     ; trop petit on met a 10 sec c'est repartit...
        bra.s _main

main_loop
        jsr userlib::idle_loop        ; une touche a ete pressee?
        cmp.w #264,d0                 ; si 264 => on se casse sans sauver
        beq.s exit
        cmp.w #344,d0                 ; si 344 alors droite: on incremente
        beq APDup
        cmp.w #338,d0                 ; si 338 alors gauche: on decremente
        beq APDdown
        cmp.w #263,d0                 ; si 263 alors clear, on remet la valeur initiale de la ti89
        beq rstAPD
        cmp.w #4434,d0                ; 2nd droite: on met a 10 sec
        beq.s petit
        cmp.w #4440,d0                ; 2nd gauche: on met a 10 min
        beq.s grand
        cmp.w #13,d0                  ; enter?
        bne.s main_loop               ; non! on revient
        move.l apd_timer,APD_INIT     ; oui: on sauve la nouvelle valeur
exit    rts                           ; au revoir et a la prochaine

APDdown cmp.l #600-95*4,apd_timer     ; on verifie si deja a 10 sec ou moins
        ble.s main_loop               ; oui alors on repart
        sub.l #95,apd_timer           ; non alors on ote 5 sec
        bra.s redraw                  ; on reaffiche les onfos
APDup   cmp.l #11410,apd_timer        ; on verifie si deja a 60 min ou plus
        bge.s main_loop               ; oui alors on repart
        add.l #95,apd_timer           ; non alors on ajoute 5 sec
        bra.s redraw                  ; on reaffiche
rstAPD  move.l #$1770,apd_timer       ; on remet 5m15s dans apd_timer 
                                      ; et on redessine
redraw  lea.l plane1(pc),a0
        moveq #9,d0                   ;
        moveq #20,d1                  ; affiche la fenetre
        move.b #$FF,d3                ;
        jsr graphlib::put_sprite_mask
        move.l apd_timer,d0
        divu #95,d0
        add.w #19,d0
        lea.l sprite(pc),a0           ; on affiche la barre de niveau
        moveq #30,d1                  ; X = 19 + APD_INIT/95
        lea.l mask(pc),a2
        jsr graphlib::put_sprite2
        move.l apd_timer,d0           ; on affiche le temps
        divu #19,d0                   ; divise par 90 pour le nombre de seconde
        and.l #$0000FFFF,d0           
        divu #60,d0                   ; divise par 60 pour min et sec
        move.w d0,d7
        clr.w d0
        swap d0                       ; remain(APD_INIT/90,60)=nombre de secondes
        bsr.s print_value             ; intdiv(APD_INIT/90,60)=nombre de minutes
        move.w #4,-(a7)
        move.l a0,-(a7)
        move.w #40,-(a7)
        move.w #84,-(a7)
        jsr doorsos::DrawStrXY        ; on affiche les secondes
        clr.l d0
        move.w d7,d0
        bsr.s print_value
        move.w #4,-(a7)
        move.l a0,-(a7)
        move.w #40,-(a7)
        move.w #47,-(a7)
        jsr doorsos::DrawStrXY        ; on affiche les minutes
        lea 20(a7),a7                 ; on restore la stack
        bra main_loop                 ; et on revient

print_value:                          ; convert d0.w en string pour l'afficher apres...
        lea.l str+2(pc),a0    
print_loop:
        divu #10,d0                   ; divise par 10 et met le reste dans a0
        swap d0                       ; en decrementant a0
        add.b #48,d0
        move.b d0,-(a0)
        clr.w d0
        swap d0                       ; si d0=0 alors fini        
        bne.s print_loop
        rts

sprite    dc.w 8                      ; l'indicateur de niveau
          dc.w 1
mask      dc.b %11100000              ; le mask est en fait aussi le sprite
          dc.b %10100000
          dc.b %01000000
          dc.b %01000000
          dc.b %01000000
          dc.b %01000000
          dc.b %10100000
          dc.b %11100000

str       dc.b "  ",0                                 ; pour les chiffres
doc       dc.b "[ESC]=quit \ [CLEAR]=reset value",0   ; un peu de doc...
apd_timer dc.l 0                                      ; valeur de l'APD

_comment  dc.b "Change APD Timer by Alban Gervaise",0 ; le commentaire

 end                                                  ; fini!
